---
title: 'typeKey'
description: 'Makes it possible to change the type property used for STI'
---

# `typeKey`

Look at [Single Table Inheritance](../../guide/model/single-table-inheritance) for more detail

## Usage

````js
import Person from './models/Person'
import Adult from './models/Adult'
import { Model } from 'pinia-orm'

class User extends Model {
  static entity = 'users'
  
  static typeKey = 'person_type'

  static types () {
    return {
      PERSON: Person,
      ADULT: Adult
    }
  }

  static fields () {
    return {
      id: this.uid(),
      name: this.string()
    }
  }
}
````

## Typescript Declarations
````ts
const typeKey: string = 'type'
````
